unit My_ActiveFormX_01Impl1;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Variants,

  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActiveX, AxCtrls, My_ActiveFormX_01_afx_TLB, StdVcl, ComCtrls, TabNotBk,
  Menus, Buttons, ExtCtrls, StdCtrls, DBCtrls, Grids, DBGrids, DB, DBTables;

type
  TMy_ActiveFormX_01 = class(TActiveForm, IMy_ActiveFormX_01)
    TN1: TTabbedNotebook;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Panel2: TPanel;
    CheckBox_Switch_01: TCheckBox;
    SpeedButton_Switch_02: TSpeedButton;
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    ListBox1: TListBox;
    Panel3: TPanel;
    DBNavigator1: TDBNavigator;
    Table_1: TTable;
    DataSource1: TDataSource;
    Panel4: TPanel;
    DBGrid1: TDBGrid;
    Splitter1: TSplitter;
    Panel5: TPanel;
    DBLabel1: TDBText;
    DBImage1: TDBImage;
    procedure SpeedButton1Click(Sender: TObject);
    procedure CheckBox_Switch_01Click(Sender: TObject);
    procedure SpeedButton_Switch_02MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton_Switch_02MouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ListBox1Click(Sender: TObject);
    procedure TN1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure Timer1Timer(Sender: TObject);
    procedure Table_1AfterOpen(DataSet: TDataSet);
    procedure Table_1AfterClose(DataSet: TDataSet);
    procedure Table_1AfterScroll(DataSet: TDataSet);
    procedure Table_1AfterInsert(DataSet: TDataSet);
    procedure Table_1AfterPost(DataSet: TDataSet);
    procedure Table_1AfterDelete(DataSet: TDataSet);
    procedure Table_1BeforeDelete(DataSet: TDataSet);
    
  private
    { Private declarations }
    FEvents: IMy_ActiveFormX_01Events;
    procedure ActivateEvent(Sender: TObject);
    procedure ClickEvent(Sender: TObject);
    procedure CreateEvent(Sender: TObject);
    procedure DblClickEvent(Sender: TObject);
    procedure DeactivateEvent(Sender: TObject);
    procedure DestroyEvent(Sender: TObject);
    procedure KeyPressEvent(Sender: TObject; var Key: Char);
    procedure PaintEvent(Sender: TObject);

    procedure MySwitchEvent(WhoIsIt: string; WhatIsIt : string);

  protected
    { Protected declarations }
    procedure DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage); override;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    function Get_Active: WordBool; safecall;
    function Get_AlignDisabled: WordBool; safecall;
    function Get_AutoScroll: WordBool; safecall;
    function Get_AutoSize: WordBool; safecall;
    function Get_AxBorderStyle: TxActiveFormBorderStyle; safecall;
    function Get_Caption: WideString; safecall;
    function Get_Color: OLE_COLOR; safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    function Get_DropTarget: WordBool; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_Font: IFontDisp; safecall;
    function Get_HelpFile: WideString; safecall;
    function Get_KeyPreview: WordBool; safecall;
    function Get_PixelsPerInch: Integer; safecall;
    function Get_PrintScale: TxPrintScale; safecall;
    function Get_Scaled: WordBool; safecall;
    function Get_ScreenSnap: WordBool; safecall;
    function Get_SnapBuffer: Integer; safecall;
    function Get_Visible: WordBool; safecall;
    function Get_VisibleDockClientCount: Integer; safecall;
    procedure _Set_Font(var Value: IFontDisp); safecall;
    procedure About; safecall;
    procedure Set_AutoScroll(Value: WordBool); safecall;
    procedure Set_AutoSize(Value: WordBool); safecall;
    procedure Set_AxBorderStyle(Value: TxActiveFormBorderStyle); safecall;
    procedure Set_Caption(const Value: WideString); safecall;
    procedure Set_Color(Value: OLE_COLOR); safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    procedure Set_DropTarget(Value: WordBool); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_Font(const Value: IFontDisp); safecall;
    procedure Set_HelpFile(const Value: WideString); safecall;
    procedure Set_KeyPreview(Value: WordBool); safecall;
    procedure Set_PixelsPerInch(Value: Integer); safecall;
    procedure Set_PrintScale(Value: TxPrintScale); safecall;
    procedure Set_Scaled(Value: WordBool); safecall;
    procedure Set_ScreenSnap(Value: WordBool); safecall;
    procedure Set_SnapBuffer(Value: Integer); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    function Get_PagesCount: Integer; safecall;
    function PageName_Get(NumPage: Integer): WideString; safecall;
    function PageName_Set(NumPage: Integer;
      const PageName: WideString): Integer; safecall;
    function FieldByName_Get(const FieldName: WideString): OleVariant;
      safecall;
    function Get_TableName: WideString; safecall;
    function Get_DatabaseName: WideString; safecall;
    function Get_FieldCount: Integer; safecall;
    function FieldByNumber_Get(FieldNumber: Integer): OleVariant; safecall;
    function FieldName_Get(FieldNumber: Integer): WideString; safecall;
    function FieldType_Get(const FieldName: WideString): WideString; safecall;
    function Field_IsBlob(const FieldName: WideString): Integer; safecall;
    function Picture_SaveToFile(const FileName: WideString): Integer; safecall;
  public
    { Public declarations }
    procedure Initialize; override;
  end;


function MyFieldType_Get(Field : TField) : string;
  
implementation

uses ComObj, ComServ, About1;

{$R *.DFM}

{ TMy_ActiveFormX_01 }

procedure TMy_ActiveFormX_01.DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage);
begin
  { Define property pages here.  Property pages are defined by calling
    DefinePropertyPage with the class id of the page.  For example,
      DefinePropertyPage(Class_My_ActiveFormX_01Page); }
end;

procedure TMy_ActiveFormX_01.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IMy_ActiveFormX_01Events;
  inherited EventSinkChanged(EventSink);
end;

procedure TMy_ActiveFormX_01.Initialize;
begin
  inherited Initialize;
  OnActivate := ActivateEvent;
  OnClick := ClickEvent;
  OnCreate := CreateEvent;
  OnDblClick := DblClickEvent;
  OnDeactivate := DeactivateEvent;
  OnDestroy := DestroyEvent;
  OnKeyPress := KeyPressEvent;
  OnPaint := PaintEvent;
  //OnSwitch := SwitchEvent;

end;

function TMy_ActiveFormX_01.Get_Active: WordBool;
begin
  Result := Active;
end;

function TMy_ActiveFormX_01.Get_AlignDisabled: WordBool;
begin
  Result := AlignDisabled;
end;

function TMy_ActiveFormX_01.Get_AutoScroll: WordBool;
begin
  Result := AutoScroll;
end;

function TMy_ActiveFormX_01.Get_AutoSize: WordBool;
begin
  Result := AutoSize;
end;

function TMy_ActiveFormX_01.Get_AxBorderStyle: TxActiveFormBorderStyle;
begin
  Result := Ord(AxBorderStyle);
end;

function TMy_ActiveFormX_01.Get_Caption: WideString;
begin
  Result := WideString(Caption);
end;

function TMy_ActiveFormX_01.Get_Color: OLE_COLOR;
begin
  Result := OLE_COLOR(Color);
end;

function TMy_ActiveFormX_01.Get_DoubleBuffered: WordBool;
begin
  Result := DoubleBuffered;
end;

function TMy_ActiveFormX_01.Get_DropTarget: WordBool;
begin
  Result := DropTarget;
end;

function TMy_ActiveFormX_01.Get_Enabled: WordBool;
begin
  Result := Enabled;
end;

function TMy_ActiveFormX_01.Get_Font: IFontDisp;
begin
  GetOleFont(Font, Result);
end;

function TMy_ActiveFormX_01.Get_HelpFile: WideString;
begin
  Result := WideString(HelpFile);
end;

function TMy_ActiveFormX_01.Get_KeyPreview: WordBool;
begin
  Result := KeyPreview;
end;

function TMy_ActiveFormX_01.Get_PixelsPerInch: Integer;
begin
  Result := PixelsPerInch;
end;

function TMy_ActiveFormX_01.Get_PrintScale: TxPrintScale;
begin
  Result := Ord(PrintScale);
end;

function TMy_ActiveFormX_01.Get_Scaled: WordBool;
begin
  Result := Scaled;
end;

function TMy_ActiveFormX_01.Get_ScreenSnap: WordBool;
begin
  Result := ScreenSnap;
end;

function TMy_ActiveFormX_01.Get_SnapBuffer: Integer;
begin
  Result := SnapBuffer;
end;

function TMy_ActiveFormX_01.Get_Visible: WordBool;
begin
  Result := Visible;
end;

function TMy_ActiveFormX_01.Get_VisibleDockClientCount: Integer;
begin
  Result := VisibleDockClientCount;
end;

procedure TMy_ActiveFormX_01._Set_Font(var Value: IFontDisp);
begin
  SetOleFont(Font, Value);
end;

procedure TMy_ActiveFormX_01.About;
begin
  ShowMy_ActiveFormX_01About;
end;

procedure TMy_ActiveFormX_01.ActivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnActivate;
end;

procedure TMy_ActiveFormX_01.ClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnClick;
end;

procedure TMy_ActiveFormX_01.CreateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnCreate;
end;

procedure TMy_ActiveFormX_01.DblClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDblClick;
end;

procedure TMy_ActiveFormX_01.DeactivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDeactivate;
end;

procedure TMy_ActiveFormX_01.DestroyEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDestroy;
end;

procedure TMy_ActiveFormX_01.KeyPressEvent(Sender: TObject; var Key: Char);
var
  TempKey: Smallint;
begin
  TempKey := Smallint(Key);
  if FEvents <> nil then FEvents.OnKeyPress(TempKey);
  Key := Char(TempKey);
end;

procedure TMy_ActiveFormX_01.PaintEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnPaint;
end;

procedure TMy_ActiveFormX_01.Set_AutoScroll(Value: WordBool);
begin
  AutoScroll := Value;
end;

procedure TMy_ActiveFormX_01.Set_AutoSize(Value: WordBool);
begin
  AutoSize := Value;
end;

procedure TMy_ActiveFormX_01.Set_AxBorderStyle(
  Value: TxActiveFormBorderStyle);
begin
  AxBorderStyle := TActiveFormBorderStyle(Value);
end;

procedure TMy_ActiveFormX_01.Set_Caption(const Value: WideString);
begin
  Caption := TCaption(Value);
end;

procedure TMy_ActiveFormX_01.Set_Color(Value: OLE_COLOR);
begin
  Color := TColor(Value);
end;

procedure TMy_ActiveFormX_01.Set_DoubleBuffered(Value: WordBool);
begin
  DoubleBuffered := Value;
end;

procedure TMy_ActiveFormX_01.Set_DropTarget(Value: WordBool);
begin
  DropTarget := Value;
end;

procedure TMy_ActiveFormX_01.Set_Enabled(Value: WordBool);
begin
  Enabled := Value;
end;

procedure TMy_ActiveFormX_01.Set_Font(const Value: IFontDisp);
begin
  SetOleFont(Font, Value);
end;

procedure TMy_ActiveFormX_01.Set_HelpFile(const Value: WideString);
begin
  HelpFile := String(Value);
end;

procedure TMy_ActiveFormX_01.Set_KeyPreview(Value: WordBool);
begin
  KeyPreview := Value;
end;

procedure TMy_ActiveFormX_01.Set_PixelsPerInch(Value: Integer);
begin
  PixelsPerInch := Value;
end;

procedure TMy_ActiveFormX_01.Set_PrintScale(Value: TxPrintScale);
begin
  PrintScale := TPrintScale(Value);
end;

procedure TMy_ActiveFormX_01.Set_Scaled(Value: WordBool);
begin
  Scaled := Value;
end;

procedure TMy_ActiveFormX_01.Set_ScreenSnap(Value: WordBool);
begin
  ScreenSnap := Value;
end;

procedure TMy_ActiveFormX_01.Set_SnapBuffer(Value: Integer);
begin
  SnapBuffer := Value;
end;

procedure TMy_ActiveFormX_01.Set_Visible(Value: WordBool);
begin
  Visible := Value;
end;


function TMy_ActiveFormX_01.Get_PagesCount: Integer;
begin
  Result:=TN1.Pages.Count;
end;

function TMy_ActiveFormX_01.PageName_Get(NumPage: Integer): WideString;
begin
  Result:='';
  if (NumPage>=0) and (NumPage<TN1.Pages.Count) then begin
     Result:=trim(TN1.Pages[NumPage]);
  end;
end;

function TMy_ActiveFormX_01.PageName_Set(NumPage: Integer;
  const PageName: WideString): Integer;
Var
  Sx : string;
begin
  Result:=0;
  if (NumPage>=0) and (NumPage<TN1.Pages.Count) then begin
     Sx:=trim(PageName);
     if length(Sx)>0 then begin
        TN1.Pages[NumPage]:=Sx;
        Result:=1;
     end;
  end;
end;

procedure TMy_ActiveFormX_01.SpeedButton1Click(Sender: TObject);
begin
  ShowMy_ActiveFormX_01About;
end;

procedure TMy_ActiveFormX_01.MySwitchEvent(WhoIsIt: string; WhatIsIt : string);
begin
  if FEvents <> nil then FEvents.OnMySwitch(WhoIsIt, WhatIsIt);
end;

procedure TMy_ActiveFormX_01.CheckBox_Switch_01Click(Sender: TObject);
Var
  iWhat : string;
begin
  if CheckBox_Switch_01.Checked then begin
     CheckBox_Switch_01.Color:=clAqua;
     CheckBox_Switch_01.Caption:='Switch_01-.';
     iWhat:='';
  end
  else begin
     CheckBox_Switch_01.Color:=clBtnFace;
     CheckBox_Switch_01.Caption:='Switch_01-.';
     iWhat:='';
  end;

  MySwitchEvent((Sender as TComponent).Name, iWhat);

  if CheckBox_Switch_01.Checked then begin
     Timer1.Enabled:=true;
  end
  else begin
     Timer1.Enabled:=false;
  end;
end;

procedure TMy_ActiveFormX_01.SpeedButton_Switch_02MouseDown(
  Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  MySwitchEvent((Sender as TComponent).Name, 'Down');
end;

procedure TMy_ActiveFormX_01.SpeedButton_Switch_02MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MySwitchEvent((Sender as TComponent).Name, 'Up');
end;

procedure TMy_ActiveFormX_01.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex>=0 then begin
     MySwitchEvent((Sender as TComponent).Name, ListBox1.Items[ListBox1.ItemIndex]);
  end;
end;

procedure TMy_ActiveFormX_01.TN1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  if NewTab<>0 then begin
     Timer1.Enabled:=false;
  end
  else begin
     if CheckBox_Switch_01.Checked then begin
        Timer1.Enabled:=true;
     end;
  end;
  if NewTab=1 then begin
     Table_1.Active:=true;
  end
  else begin
     Table_1.Active:=false;
  end;

end;

procedure TMy_ActiveFormX_01.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=false;
  MySwitchEvent((Sender as TComponent).Name, DateTimeToStr(NOW));
  Timer1.Enabled:=true;
end;

procedure TMy_ActiveFormX_01.Table_1AfterOpen(DataSet: TDataSet);
begin
  MySwitchEvent((DataSet as TComponent).Name, 'AfterOpen');
end;

procedure TMy_ActiveFormX_01.Table_1AfterClose(DataSet: TDataSet);
begin
  MySwitchEvent((DataSet as TComponent).Name, 'AfterClose');
end;

procedure TMy_ActiveFormX_01.Table_1AfterScroll(DataSet: TDataSet);
begin
  MySwitchEvent((DataSet as TComponent).Name, 'AfterScroll : Species_No='+Table_1.FieldByName('Species No').AsString);
end;

procedure TMy_ActiveFormX_01.Table_1AfterInsert(DataSet: TDataSet);
begin
  MySwitchEvent((DataSet as TComponent).Name, 'AfterInsert : Species_No='+Table_1.FieldByName('Species No').AsString);
end;

procedure TMy_ActiveFormX_01.Table_1AfterPost(DataSet: TDataSet);
begin
  MySwitchEvent((DataSet as TComponent).Name, 'AfterPost : Species_No='+Table_1.FieldByName('Species No').AsString);
end;

procedure TMy_ActiveFormX_01.Table_1AfterDelete(DataSet: TDataSet);
begin
  MySwitchEvent((DataSet as TComponent).Name, 'AfterDelete : Species_No='+Table_1.FieldByName('Species No').AsString);
end;

procedure TMy_ActiveFormX_01.Table_1BeforeDelete(DataSet: TDataSet);
begin
  MySwitchEvent((DataSet as TComponent).Name, 'BeforeDelete : Species_No='+Table_1.FieldByName('Species No').AsString);
end;

function TMy_ActiveFormX_01.Get_TableName: WideString;
begin
  Result:=trim(Table_1.TableName);
end;

function TMy_ActiveFormX_01.Get_DatabaseName: WideString;
begin
  Result:=trim(Table_1.DatabaseName);
end;

function TMy_ActiveFormX_01.Get_FieldCount: Integer;
begin
  Result:=0;
  if Table_1.Active then begin
     Result:=Table_1.Fields.Count;
  end;
end;

function TMy_ActiveFormX_01.FieldByNumber_Get(FieldNumber: Integer): OleVariant;
begin
  Result:=UnAssigned;
  if Table_1.Active then begin
     if (FieldNumber>=0) and (FieldNumber<Table_1.Fields.Count) then begin
        Result:=Table_1.Fields[FieldNumber].AsVariant;
     end;
  end;
end;


function TMy_ActiveFormX_01.FieldByName_Get(const FieldName: WideString): OleVariant;
Var
  fn : string;
begin
  Result:=UnAssigned;
  fn:=trim(FieldName);
  if length(fn)>0 then begin
     if Table_1.Active then begin
        Result:=Table_1.FieldByName(fn).AsVariant;
     end;
  end;
end;

function TMy_ActiveFormX_01.FieldName_Get(FieldNumber: Integer): WideString;
begin
  Result:='';
  if Table_1.Active then begin
     if (FieldNumber>=0) and (FieldNumber<Table_1.Fields.Count) then begin
        Result:=trim(Table_1.Fields[FieldNumber].FieldName);
     end;
  end;
end;


function MyFieldType_Get(Field : TField) : string;
begin
  Result:='';
  if Field.DataType = ftString then begin
     Result:='String';
  end;
  if Field.DataType = ftSmallint then begin
     Result:='Smallint';
  end;
  if Field.DataType = ftInteger then begin
     Result:='Integer';
  end;
  if Field.DataType = ftWord then begin
     Result:='Word';
  end;
  if Field.DataType = ftBytes then begin
     Result:='Bytes';
  end;
  if Field.DataType = ftVarBytes then begin
     Result:='VarBytes';
  end;
  if Field.DataType = ftAutoInc then begin
     Result:='AutoInc';
  end;
  if Field.DataType = ftFloat then begin
     Result:='Float';
  end;
  if Field.DataType = ftCurrency then begin
     Result:='Currency';
  end;
  if Field.DataType = ftBCD then begin
     Result:='BCD';
  end;
  if Field.DataType = ftDate then begin
     Result:='Date';
  end;
  if Field.DataType = ftDateTime then begin
     Result:='DateTime';
  end;
  if Field.DataType = ftTime then begin
     Result:='Time';
  end;
  if Field.DataType = ftBoolean then begin
     Result:='Boolean';
  end;
  if Field.DataType = ftBlob then begin
     Result:='Blob';
  end;
  if Field.DataType = ftMemo then begin
     Result:='Memo';
  end;
  if Field.DataType = ftGraphic then begin
     Result:='Graphic';
  end;
end;

function TMy_ActiveFormX_01.FieldType_Get(const FieldName: WideString): WideString;
Var
  fn : string;
begin
  Result:='';
  fn:=trim(FieldName);
  if length(fn)>0 then begin
     if Table_1.Active then begin
        Result:=trim(MyFieldType_Get(Table_1.FieldByName(fn)));
     end;
  end;
end;


function TMy_ActiveFormX_01.Field_IsBlob(const FieldName: WideString): Integer;
Var
  fn : string;
begin
  Result:=0;
  fn:=trim(FieldName);
  if length(fn)>0 then begin
     if Table_1.Active then begin
        if Table_1.FieldByName(fn).IsBlob then Result:=1;
     end;
  end;
end;

function TMy_ActiveFormX_01.Picture_SaveToFile(const FileName: WideString): Integer;
Var
  fn : string;
begin
  Result:=0;
  fn:=trim(FileName);
  if length(fn)>0 then begin
     if DBImage1.Picture<>NIL then begin
        DBImage1.Picture.SaveToFile(fn);
        Result:=1;
     end;
  end;
end;


initialization
  TActiveFormFactory.Create(
    ComServer,
    TActiveFormControl,
    TMy_ActiveFormX_01,
    Class_My_ActiveFormX_01,
    1,
    '',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL,
    tmApartment);
end.


